var
	bUpdating: boolean;
	vLastResult: Variant;
	IVA1, IVA2, IVA3, RE1, RE2, RE3, IRPF, TOTAL: double;


function FindField(ds: TDataSet; sFieldName: string):boolean;
var
	i: integer;
begin
	result:= false;
	
	for i:=0 to ds.FieldCount-1 do
	  if ds.Fields[i].FieldName = sFieldName then
		result:= true;
		
end;

procedure FillInDataSet(pO, pD: TDataSet; sFieldIgnore: string);
var
	i: integer;
begin
	for i:=0 to pD.FieldCount-1 do
		if FindField(pO, pD.Fields[i].FieldName) and not(Pos(pD.Fields[i].FieldName, sFieldIgnore)>0) and not(pD.Fields[i] is TAutoIncField) then
		begin
			//showmessage(pD.Fields[i].FieldName);
			pD.Fields[i].Value := pO.FieldByName(pD.Fields[i].FieldName).Value;
			
		end;
end;

function ParseQuery(sQuery: String):String;
begin
	Result:=zReplace(sQuery, '''', '''''');
end;


function CalcularPrecios(sField: String):double;
var
   dBases, dIVAs, dREs:array[1..3] of double;
   nCantidad, dPrecio, dDescuento, dIva, dIRPF, dCoeficiente: double;
   IdIva, f: integer;
   bExiste: boolean;
   bm: string;
begin

  IdIva := 0;
  bExiste := false;
  for f := 1 to 3 do
  begin
       dBases[f] := 0;
       dIVAs[f] := 0;
       dREs[f] := 0;
  end;
  

  
	ClientDataSetMaster.Edit;
	ClientDataSetMaster.FieldByName('BaseImponible1').AsString := '';
	ClientDataSetMaster.FieldByName('BaseImponible2').AsString := '';
	ClientDataSetMaster.FieldByName('BaseImponible3').AsString := '';
	ClientDataSetMaster.FieldByName('IVA1').AsString := '';
	ClientDataSetMaster.FieldByName('IVA2').AsString := '';
	ClientDataSetMaster.FieldByName('IVA3').AsString := '';
	ClientDataSetMaster.FieldByName('RE1').AsString := '';
	ClientDataSetMaster.FieldByName('RE2').AsString := '';
	ClientDataSetMaster.FieldByName('RE3').AsString := '';
	
	ClientDataSetMaster.FieldByName('TotalDescuento').AsString := '';
	
	ClientDataSetMaster.FieldByName('TotalIVA1').AsString := '';
	ClientDataSetMaster.FieldByName('TotalIVA2').AsString := '';
	ClientDataSetMaster.FieldByName('TotalIVA3').AsString := '';
	
	ClientDataSetMaster.FieldByName('TotalRE1').AsString := '';
	ClientDataSetMaster.FieldByName('TotalRE2').AsString := '';
	ClientDataSetMaster.FieldByName('TotalRE3').AsString := '';
	
	ClientDataSetMaster.FieldByName('TotalIRPF').AsString := '';
	
	ClientDataSetMaster.FieldByName('TOTAL').AsString := '';

	if (ClientDataSetDetalles.Eof) and (ClientDataSetDetalles.Bof) then exit;
	
	bm := ClientDataSetDetalles.Fields[0].AsString;
	ClientDataSetDetalles.DisableControls();
	
	ClientDataSetDetalles.First;

	while not ClientDataSetDetalles.Eof do
	begin

		
		
      nCantidad := ClientDataSetDetalles.FieldByName('Cantidad').AsFloat;
      dPrecio := zRound(ClientDataSetDetalles.FieldByName('Precio').AsFloat, QueryConfiguracion.FieldByName('DecimalesMoneda').AsInteger);
      dDescuento := ClientDataSetDetalles.FieldByName('Descuento').AsFloat;
      dIva := ClientDataSetDetalles.FieldByName('IVA').AsFloat;
	  
	  {dCoeficiente := 1;	  
	  if FindField(ClientDataSetDetalles, 'Coeficiente') then
		dCoeficiente := ClientDataSetDetalles.FieldByName('Coeficiente').AsFloat;}

      if (nCantidad = 0)  then
        begin
            ClientDataSetDetalles.Next;
            continue;
        end;
		
	 
	
	 ClientDataSetDetalles.Edit;
	 if sField = 'Importe' then
	 begin		
		ClientDataSetDetalles.FieldByName('Precio').AsFloat := zRound(ClientDataSetDetalles.FieldByName('Importe').AsFloat / nCantidad / (dIVA/100 + 1) / (1 - dDescuento/100), QueryConfiguracion.FieldByName('DecimalesMoneda').AsInteger);
	 end
	 else
		ClientDataSetDetalles.FieldByName('Importe').AsFloat := zRound(nCantidad * ( dPrecio * (100 - dDescuento ) / 100 )) * ((dIVA/100 + 1));	

      // Para cada tipo de IVA
      if ( IdIva = 0 ) then
      begin
           IdIva := IdIva + 1;

            dIVAs[IdIva] := dIva;
            dBases[IdIva] := dBases[IdIva] + zRound(nCantidad * ( dPrecio * (100 - dDescuento ) / 100 ));


      end
      else
      begin
            // Recorrer todos los IVAS para ver si ya esta en la lista
            bExiste := false;
            for f := 1 to IdIva do
            begin
                if ( dIVAs[f] = dIva ) then
                begin
                    dBases[f] := dBases[f] + zRound( nCantidad * ( dPrecio * (100 - dDescuento ) / 100 ));
                    bExiste := true;
                end;
            end;
            if ( not bExiste ) then  // Nuevo tipo de iva
            begin
                 IdIva := IdIva + 1;
				 
				 if idIVA > 3 then		 
					idIVA := 3;
				 

                dIVAs[IdIva] := dIva;
                dBases[IdIva] := dBases[IdIva] + zRound( nCantidad * ( dPrecio * (100 - dDescuento ) / 100 ));


            end;
      end;


	ClientDataSetDetalles.Next;

	end;
	
	
	if bm <> '' then	
		ClientDataSetDetalles.Locate(ClientDataSetDetalles.Fields[0].FieldName, bm, loCaseInsensitive);	
	
	ClientDataSetDetalles.EnableControls();
	
	



	// DESCUENTO GENERAL
	for f := 1 to IdIva do
    begin

        dDescuento := (ClientDataSetMaster.FieldByName('Descuento').AsFloat / 100);


		dDescuento := zRound(dDescuento * dBases[f]);

		dBases[f] := dBases[f] - dDescuento;

		dBases[f] := zRound(dBases[f]);


    end;


	// BASES E IVA, RE
    ClientDataSetMaster.Edit;
    for f := 1 to IdIva do
    begin
         ClientDataSetMaster.FieldByName('BaseImponible' + IntToStr(f)).AsFloat := dBases[f];
         ClientDataSetMaster.FieldByName('IVA' + IntToStr(f)).AsFloat := dIVAs[f];
		 

		 if ClientDataSetMaster.FieldByName('ConRE').AsBoolean then
		 begin
			if dIVAs[f] = QueryConfiguracion.FieldByName('IVAGeneral').AsFloat then
                ClientDataSetMaster.FieldByName('RE' + IntToStr(f)).AsFloat := QueryConfiguracion.FieldByName('REGeneral').AsFloat
			else
			if dIVAs[f] = QueryConfiguracion.FieldByName('IVAReducido').AsFloat then
                ClientDataSetMaster.FieldByName('RE' + IntToStr(f)).AsFloat := QueryConfiguracion.FieldByName('REReducido').AsFloat
			else
			if dIVAs[f] = QueryConfiguracion.FieldByName('IVASuperReducido').AsFloat then
                ClientDataSetMaster.FieldByName('RE' + IntToStr(f)).AsFloat := QueryConfiguracion.FieldByName('RESuperReducido').AsFloat;
		 end;

    end;
    //ClientDataSetMaster.Post;

		//
		
    IVA1 := zRound(ClientDataSetMaster.FieldByName('BaseImponible1').AsFloat * ClientDataSetMaster.FieldByName('IVA1').AsFloat/100);
    IVA2 := zRound(ClientDataSetMaster.FieldByName('BaseImponible2').AsFloat * ClientDataSetMaster.FieldByName('IVA2').AsFloat/100);
    IVA3 := zRound(ClientDataSetMaster.FieldByName('BaseImponible3').AsFloat * ClientDataSetMaster.FieldByName('IVA3').AsFloat/100);

    RE1 := zRound(ClientDataSetMaster.FieldByName('BaseImponible1').AsFloat * ClientDataSetMaster.FieldByName('RE1').AsFloat/100);
    RE2 := zRound(ClientDataSetMaster.FieldByName('BaseImponible2').AsFloat * ClientDataSetMaster.FieldByName('RE2').AsFloat/100);
    RE3 := zRound(ClientDataSetMaster.FieldByName('BaseImponible3').AsFloat * ClientDataSetMaster.FieldByName('RE3').AsFloat/100);

	IRPF := 0;
    if ClientDataSetMaster.FieldByName('ConIRPF').AsBoolean then
	begin
		IRPF := ClientDataSetMaster.FieldByName('BaseImponible1').AsFloat + ClientDataSetMaster.FieldByName('BaseImponible2').AsFloat + ClientDataSetMaster.FieldByName('BaseImponible3').AsFloat;
		
		if QueryConfiguracion.FieldByName('CalcularIRPFGlobal').AsBoolean then
				IRPF := IRPF + IVA1 + IVA2 + IVA3;
				
		IRPF := zRound(ClientDataSetMaster.FieldByName('IRPF').AsFloat / 100 * (IRPF));
		 
	end
	else
		ClientDataSetMaster.FieldByName('IRPF').AsFloat := 0;


	TOTAL :=
		ClientDataSetMaster.FieldByName('BaseImponible1').AsFloat+
		ClientDataSetMaster.FieldByName('BaseImponible2').AsFloat+
		ClientDataSetMaster.FieldByName('BaseImponible3').AsFloat+
		IVA1+IVA2+IVA3+
		RE1+RE2+RE3
		-
		IRPF;
		
		
	if dDescuento <> 0 then
	ClientDataSetMaster.FieldByName('TotalDescuento').AsFloat := dDescuento;
	
	if IVA1 <> 0 then
	ClientDataSetMaster.FieldByName('TotalIVA1').AsFloat := IVA1;
	if IVA2 <> 0 then
	ClientDataSetMaster.FieldByName('TotalIVA2').AsFloat := IVA2;
	if IVA3 <> 0 then
	ClientDataSetMaster.FieldByName('TotalIVA3').AsFloat := IVA3;
	
	if RE1 <> 0 then
	ClientDataSetMaster.FieldByName('TotalRE1').AsFloat := RE1;
	if RE2 <> 0 then
	ClientDataSetMaster.FieldByName('TotalRE2').AsFloat := RE2;
	if RE3 <> 0 then
	ClientDataSetMaster.FieldByName('TotalRE3').AsFloat := RE3;
	
	if IRPF <> 0 then
	ClientDataSetMaster.FieldByName('TotalIRPF').AsFloat := IRPF;
	
	ClientDataSetMaster.FieldByName('TOTAL').AsFloat := TOTAL;

	

	Result := TOTAL;

end;

procedure SinIVA();
var
	bm: string;
begin
	if (ClientDataSetDetalles.Eof) and (ClientDataSetDetalles.Bof) then exit;
	
	bm := ClientDataSetDetalles.Fields[0].AsString;
	ClientDataSetDetalles.DisableControls();
	
// Quitar IVA de los productos
	if ClientDataSetMaster.FieldByName('SinIVA').AsBoolean then
	begin
    ClientDataSetDetalles.First();
		while not ClientDataSetDetalles.Eof do
		begin
			ClientDataSetDetalles.Edit();
			ClientDataSetDetalles.FieldByName('IVA').AsFloat := 0;
			//DataSourceDetalles.Post();

      ClientDataSetDetalles.Next();
		end;
	end
	else // Añadir el IVA de cada producto
	begin
    ClientDataSetDetalles.First();
		while not ClientDataSetDetalles.Eof do
		begin
			Query.SQL.Text := 'SELECT IVA FROM PRODUCTOS WHERE ID_PRODUCTOS = ''' + ClientDataSetDetalles.FieldByName('ID_PRODUCTOS').AsString + '''';
			Query.Active := true;

			if not Query.Eof then
			begin
				ClientDataSetDetalles.Edit();
				ClientDataSetDetalles.FieldByName('IVA').AsFloat := Query.FieldByName('IVA').AsFloat;
				//DataSourceDetalles.Post();
			end;

      ClientDataSetDetalles.Next();

		end;
	end;
	
	ClientDataSetDetalles.Locate(ClientDataSetDetalles.Fields[0].FieldName, bm, loCaseInsensitive);		
	ClientDataSetDetalles.EnableControls();
end;



procedure ProductosChange(sKey: string);
var
  sPrecio: string;
  
begin
	
	//ShowMessage(sKey);

	if sKey = 'Descripcion' then
		Query.SQL.Text := 'SELECT * FROM PRODUCTOS WHERE Nombre = ''' + ParseQuery(ClientDataSetDetalles.FieldByName(sKey).AsString) + ''''
	else
		Query.SQL.Text := 'SELECT * FROM PRODUCTOS WHERE '+sKey+' = ''' + ParseQuery(ClientDataSetDetalles.FieldByName(sKey).AsString) + '''';	
		
    Query.Active := true;

    if not Query.Eof then
    begin
	  ClientDataSetDetalles.Edit;	
	  
	  /// CUSTOM FIELDS
	  FillInDataSet(Query, ClientDataSetDetalles, '');
	  
      ClientDataSetDetalles.FieldByName('ID_PRODUCTOS').AsString := Query.FieldByName('ID_PRODUCTOS').AsString;
      ClientDataSetDetalles.FieldByName('Descripcion').AsString := Query.FieldByName('Nombre').AsString;
      ClientDataSetDetalles.FieldByName('Cantidad').AsFloat := 1;
      ClientDataSetDetalles.FieldByName('Descuento').AsFloat := Query.FieldByName('Descuento').AsFloat;

     
      sPrecio := 'Precio';

      ClientDataSetDetalles.FieldByName('Precio').AsFloat := Query.FieldByName(sPrecio).AsFloat;
      ClientDataSetDetalles.FieldByName('IVA').AsFloat := Query.FieldByName('IVA').AsFloat;	

	  if ClientDataSetMaster.FieldByName('SinIVA').AsBoolean then
			ClientDataSetDetalles.FieldByName('IVA').AsFloat := 0;
			
      ClientDataSetDetalles.Post;
	  
	  CalcularPrecios('');
	  	  
	  
	  //ClientDataSetDetalles.AfterPost := nil;
	  
	  //ShowMessage('a');
	  Query.Tag := 1; // append
		
	  

	end;
	
	

end;

procedure ID_PartnerChange(sKey: string);
var
	DSPartner : TDataSet;
begin
	//ShowMessage(sKey);
	
	DSPartner := QueryClientes;
	if FindField(ClientDataSetMaster, 'ID_PROVEEDORES') then
			DSPartner := QueryProveedores;
	
	if not DSPartner.Locate(sKey, ClientDataSetMaster.FieldByName(sKey).AsString, loCaseInsensitive) then exit;
	
    ClientDataSetMaster.Edit();
	
	/// CUSTOM FIELDS
	FillInDataSet(DSPartner, ClientDataSetMaster, sKey);
	
end;



procedure TZDBFormListProductosCloseQuery(Sender: TObject; var CanClose: Boolean);
var
	pFormList: TZDBFormListProductos;
begin
	pFormList:= TZDBFormListProductos(Sender);

	if pFormList.ModalResult <> mrOk then exit;

	ClientDataSetDetalles.Edit;
	ClientDataSetDetalles.FieldByName('ID_PRODUCTOS').AsString := zGetCurrentValue(pFormList, 'ID_PRODUCTOS');
end;

procedure SeleccionarProducto(sValues: String);
var
	pFormList: TZDBFormListProductos;
begin

	
	
	pFormList := TZDBFormListProductos.Create(zGetActiveForm);	
	pFormList.Parent := zGetActiveForm;
	pFormList.OnCloseQuery := 'TZDBFormListProductosCloseQuery';

	pFormList.Show;

	
end;

procedure TZDBFormListClientesCloseQuery(Sender: TObject; var CanClose: Boolean);
var
	pFormList: TZDBFormListClientes;
begin
	pFormList:= TZDBFormListClientes(Sender);

	if pFormList.ModalResult <> mrOk then exit;

	ClientDataSetMaster.Edit;
	ClientDataSetMaster.FieldByName('ID_CLIENTES').AsString := zGetCurrentValue(pFormList, 'ID_CLIENTES');
end;

procedure TZDBFormListProveedoresCloseQuery(Sender: TObject; var CanClose: Boolean);
var
	pFormList: TZDBFormListProveedores;
begin
	pFormList:= TZDBFormListProveedores(Sender);

	if pFormList.ModalResult <> mrOk then exit;

	ClientDataSetMaster.Edit;
	ClientDataSetMaster.FieldByName('ID_PROVEEDORES').AsString := zGetCurrentValue(pFormList, 'ID_PROVEEDORES');
end;



procedure SeleccionarTercero(sValues: String);
var
	pFormListClientes: TZDBFormListClientes;
	pFormListProveedores: TZDBFormListProveedores;	
begin
	if sValues = 'ID_CLIENTES' then
	begin

		pFormListClientes := TZDBFormListClientes.Create(zGetActiveForm);
		pFormListClientes.Parent := zGetActiveForm;
		pFormListClientes.OnCloseQuery := 'TZDBFormListClientesCloseQuery';
		pFormListClientes.Show;
	end
	else
	begin
		pFormListProveedores := TZDBFormListProveedores.Create(zGetActiveForm);
		pFormListProveedores.Parent := zGetActiveForm;
		pFormListProveedores.OnCloseQuery := 'TZDBFormListProveedoresCloseQuery';
		pFormListProveedores.Show;
	end;
	
end;


function DataChange(sValues: String):double;
var
	pL: TStringList;
		dDescuento, dIVA: double;		
		sField, sDataSet: string;
		i: integer;
		pDS: TDataSet;
begin

	if bUpdating then exit;
		bUpdating := true;	
	
	
	pL := TStringList.Create();
	pL.CommaText := sValues;	
	sDataSet:= pL.Values['DataSet'];
	sField:= pL.Values['Field'];	
	pL.Free;
	
	//zAlert(sDataSet, sField);
	
	if sDataSet = 'ClientDataSetDetalles' then
	begin
		if (sField = 'Cantidad') or (sField = 'Precio') or (sField = 'Importe') or (sField = 'IVA') or (sField = 'Descuento') then
			CalcularPrecios(sField);
		if (sField = 'Descripcion' ) or (sField = 'ID_PRODUCTOS') then
			ProductosChange(sField);
						  

	end;
	
	if sDataSet = 'ClientDataSetMaster' then	
	begin 
		if (sField = 'ID_CLIENTES') or (sField = 'ID_PROVEEDORES') or (sField = 'Nombre') then
			ID_PartnerChange(sField);
		if (sField = 'Descuento') then
			CalcularPrecios('');
		if (sField = 'ConIRPF') then
			CalcularPrecios('');			
		if (sField = 'IRPF') then
			CalcularPrecios('');	
		if (sField = 'ConRE') then
			CalcularPrecios('');
		if (sField = 'TotalEntrega') then
		begin
			ClientDataSetMaster.FieldByName('TotalCambio').AsFloat := zRound(ClientDataSetMaster.FieldByName('TotalEntrega').AsFloat - ClientDataSetMaster.FieldByName('TOTAL').AsFloat);
		end;
		if (sField = 'SinIVA') then
		begin
			SinIVA();
			CalcularPrecios('');
		end;
		

	end;
	
	
    
	
	bUpdating := false;

	Result := 0;

end;


function FormCloseQuery(sValues: String):boolean;
begin
	Result := true;

end;

function FormShow(sValues: String):boolean;
begin
	
	


end;







begin

end.
